.\"	$NetBSD: atomic_swap.3,v 1.3 2008/04/30 13:10:46 martin Exp $
.\"
.\" Copyright (c) 2007 The NetBSD Foundation, Inc.
.\" All rights reserved.
.\"
.\" This code is derived from software contributed to The NetBSD Foundation
.\" by Jason R. Thorpe.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\" notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\" notice, this list of conditions and the following disclaimer in the
.\" documentation and/or other materials provided with the distribution.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE NETBSD FOUNDATION, INC. AND CONTRIBUTORS
.\" ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
.\" TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
.\" PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE FOUNDATION OR CONTRIBUTORS
.\" BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
.\" CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
.\" SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
.\" INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
.\" CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
.\" ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
.\" POSSIBILITY OF SUCH DAMAGE.
.\"
.Dd April 11, 2007
.Dt ATOMIC_SWAP 3
.Os
.Sh NAME
.Nm atomic_swap ,
.Nm atomic_swap_32 ,
.Nm atomic_swap_uint ,
.Nm atomic_swap_ulong ,
.Nm atomic_swap_ptr ,
.Nm atomic_swap_64
.Nd atomic swap operations
.\" .Sh LIBRARY
.\" .Lb libc
.Sh SYNOPSIS
.In sys/atomic.h
.Ft uint32_t
.Fn atomic_swap_32 "volatile uint32_t *ptr" "uint32_t new"
.Ft unsigned int
.Fn atomic_swap_uint "volatile unsigned int *ptr" "unsigned int new"
.Ft unsigned long
.Fn atomic_swap_ulong "volatile unsigned long *ptr" "unsigned long new"
.Ft void *
.Fn atomic_swap_ptr "volatile void *ptr" "void *new"
.Ft uint64_t
.Fn atomic_swap_64 "volatile uint64_t *ptr" "uint64_t new"
.Sh DESCRIPTION
The
.Nm atomic_swap
family of functions perform a swap operation in an atomic fashion.
The value of the variable referenced by
.Fa ptr
is replaced by
.Fa new
and the old value returned.
.Pp
The 64-bit variants of these functions are available only on platforms
that can support atomic 64-bit memory access.
Applications can check for the availability of 64-bit atomic memory
operations by testing if the pre-processor macro
.Dv __HAVE_ATOMIC64_OPS
is defined.
.Sh SEE ALSO
.Xr atomic_ops 3
.Sh HISTORY
The
.Nm atomic_swap
functions first appeared in
.Nx 5.0 .
